globals
      [
        data
        data-pointer
        data-length
        stucurbldg             ;; Student current building
        stucurroom             ;; student current classrooom
        studestbldg            ;; student destination building
        studestroom            ;; student destination classroom
        stucurlat              ;; student current latitiude
        stucurlon              ;; student current longitude
        stucurhead             ;; student current heading
        stucurbell             ;; student current bell
        studestroom1           ;; student destination first bell
        studestroom2           ;; student destination second bell
        studestroom3           ;; student destination third bell
        studestroom4           ;; student destination forth bell
        studestroom5           ;; student destination fifth bell
        studestroom6           ;; student destination sixth bell
        studestroom7           ;; student destination seventh bell
        last-waypoint          ;; last-waypoint = 1 when last waypoint reached for a student route
        steps                  ;; steps turtle is to move
        outofworld             ;; current or destination of student is out of the boundaries of the patch
        studestlat             ;; destination of student x value
        studestlon             ;; destination of student y val
        studesthead            ;; student heading
        student-dest-xcor                             ;; Student destination x coordinate
        student-dest-ycor                             ;; Student destination y coordinate

        wmcurlat
        wmcurlon
        wmhead
        wmdestlat
        wmdestlon
        repeatval


        building
        image-file
        waypoint-location

        check-type
        curr-xcor
        curr-ycor
        date
        datetime
        file-name
        mouse-clicked

         waypoint-record


 ;;      Waypoints
          waypoint-building                             ;; Waypoint building
          waypoint-id                                   ;; Waypoint Identifier
          waypoint-type                                 ;; Waypoint type
          waypoint-xcor                                 ;; Waypoint xcor
          waypoint-ycor                                 ;; Waypoint ycor
          waypoint-color                                ;; Waypoint Patch Color
          world-view
          waypoint-csv-file
          time
          layout-file-name

 ;; Wall Layout Record Format
          layout-record
          layout-building                               ;; item 0
          layout-orientation                            ;; item 1
          layout-type                                   ;; item 2
          layout-color                                  ;; item 3
          layout-ns-start-xcor                          ;; item 4
          layout-ns-start-ycor                          ;; item 5
          layout-ns-end-xcor                            ;; item 6
          layout-ns-end-ycor                            ;; item 7
          layout-ew-start-xcor                          ;; item 8
          layout-ew-start-ycor                          ;; item 9
          layout-ew-end-xcor                            ;; item 10
          layout-ew-end-ycor                            ;; item 11
          layout-heading                                ;; item 12

  ;; Classroom Label Format
          label-record
          label-building                                ;; item 0
          label-classroom-label                         ;; item 1
          label-xcor                                    ;; item 2
          label-ycor                                    ;; item 3


;; Routes record layout
          route-record
          route-currbldg                               ;; itme 0
          route-currclrm                               ;; item 1
          route-destbldg                               ;; item 2
          route-destclrm                               ;; item 3
          route-wayptxcor                              ;; item 4
          route-wayptycor                              ;; item 5
          route-waypthead                              ;; item 6
          route-wayptremain                            ;; item 7
          route-wayptbel                               ;; itme 8

]



extensions [csv]              ;; Included routines to read .csv paramenter files

breed [wall-makers wall-maker]  ;; Breed and turtle for building layout
breed [waypoints waypoint]
breed [students student]

to setup

  clear-all
  file-close-all
  ask patches [ set pcolor white ]


   create-turtles 1 [
                    set breed wall-makers set color red

               ;;     set shape "person"
                    set curr-xcor 0
                    set curr-ycor 0
                    set size 4 setxy curr-xcor curr-ycor
                   ]
  set building "High School"
  set stucurbldg  building
  ask turtles [ layoutbuilding]
  markwaypoints
  set studestroom1 0           ;; student destination first bell
  set studestroom2 0           ;; student destination second bell
  set studestroom3 0           ;; student destination third bell
  set studestroom4 0           ;; student destination forth bell
  set studestroom5 0           ;; student destination fifth bell
  set studestroom6 0           ;; student destination sixth bell
  set studestroom7 0           ;; student destination seventh bell
  reset-ticks

end
to layoutbuilding


  set layout-file-name (word building "_layout.csv")
  file-open layout-file-name
  set layout-record csv:from-row file-read-line   ; skip header record
  ask wall-makers [
     while [not file-at-end?]
    [
      set layout-record csv:from-row file-read-line ; read building layout paramenters

      set layout-building item 0 layout-record
      set layout-orientation item 1 layout-record
      set layout-type item 2 layout-record
      set layout-color item 3 layout-record
      set layout-ns-start-xcor item 4 layout-record
      set layout-ns-start-ycor item 5 layout-record
      set layout-ns-end-xcor item 6 layout-record
      set layout-ns-end-ycor item 7 layout-record
      set layout-ew-start-xcor item 8 layout-record
      set layout-ew-start-ycor item 9 layout-record
      set layout-ew-end-xcor item 10 layout-record
      set layout-ew-end-ycor item 11 layout-record
      set layout-heading item 12 layout-record
      set layout-building building

       if layout-orientation = "NS"
        [
           set   xcor layout-ns-start-xcor
           set   ycor layout-ns-start-ycor
           set repeatval abs layout-ns-start-ycor - abs layout-ns-end-ycor
           setxy xcor ycor
           set heading 180
           while [ycor > layout-ns-end-ycor]
             [
               ask wall-maker 0 [set pcolor layout-color]  ;; set the patch color
                ask wall-maker 0 [set plabel-color layout-color]
                set check-type substring layout-type  0 2
                ask wall-maker 0 [set pcolor layout-color]
                ask wall-maker 0 [ fd 1 ]
            ]
        ]

if layout-orientation = "EW"
        [
           set   xcor layout-ew-start-xcor
           set   ycor layout-ew-start-ycor
           setxy xcor ycor
           set heading 90
           while [xcor < layout-ew-end-xcor]
             [
                ask wall-maker 0 [set pcolor layout-color]  ;; set the patch color
                ask wall-maker 0 [set plabel-color layout-color]
                set check-type substring layout-type  0 2
                ask wall-maker 0 [set pcolor layout-color]
                ask wall-maker 0 [ fd 1 ]
            ]
        ]

    ]


  ]
  set file-name (word building "_layout.csv")


  file-close

       set file-name (word building "_Classrooms.csv")

     file-open file-name

     set label-record csv:from-row file-read-line ; skip header record

     while [not file-at-end?]
    [
          set label-record csv:from-row file-read-line ; read classroom label paramenters



       set label-classroom-label item 1 label-record
        set label-xcor item 2 label-record
        set label-ycor item 3 label-record
         set xcor label-xcor
         set ycor label-ycor         ;; get the y coordinate of the click as an integer
         setxy xcor ycor
         ask wall-maker 0 [set plabel-color black]
         ask wall-maker 0 [set plabel label-classroom-label]

   ;;     ask wall-maker 0 [fd 1]
  ]

 file-close



end





to markwaypoints

  file-close-all                      ;; close any open files
  set file-name (word stucurbldg "_waypoints.csv")
   set data-length 0
  set data-pointer 0
  file-open file-name
  set data csv:from-row file-read-line    ; skip the heading record

 read-waypoint-layout

 file-close-all
 clear-turtles

end

to read-waypoint-layout

  crt 1 [
   set breed waypoints set color red

                    set shape "person"
 ;;                   set curr-xcor 210
   ;;                 set curr-ycor -32
                    set size 6
    ;;             setxy curr-xcor curr-ycor
  ]

    while [not file-at-end?]
    [
      set data csv:from-row file-read-line ; read waypoint layout paramentersbuilding waypoint-location waypoint-id waypoint-type waypoint-xcor waypoint-ycor waypoint-color

    ask waypoints
         [
            setxy item 4 data item 5 data
;;            set heading item 5 data
            set pcolor item 6 data
            set plabel item 2 data
            set plabel-color item 6 data
            fd 1


          ]

     ]

end









to create_student

  create-turtles 1 [
                    set breed students set color red
                    set shape "person"
                    set size 6  setxy stucurlat stucurlon
                   ]

  ask turtles
      [
        set label who
      ]

  file-close-all

  set file-name "student 1 schedule.csv"  ; set data-source
  set data-length 0
  set data-pointer 0
  file-open file-name
  set data csv:from-row file-read-line ; read to skip the heading line

  read-student-schedule
  file-close-all


end

to read-student-schedule

  let loopcnt  0
  while [not file-at-end?]
    [

      set data csv:from-row file-read-line
      set loopcnt  loopcnt + 1

      if loopcnt = 1  [ set studestroom1 item 2 data]
      if loopcnt = 2  [ set studestroom2 item 2 data]
      if loopcnt = 3  [ set studestroom3 item 2 data]
      if loopcnt = 4  [ set studestroom4 item 2 data]
      if loopcnt = 5  [ set studestroom5 item 2 data]
      if loopcnt = 6  [ set studestroom6 item 2 data]
      if loopcnt = 7  [ set studestroom7 item 2 data]

    ]


  file-close-all

end

to next-class
  set stucurbell (stucurbell + 1)
;  set last-waypoint 0
  get-route

end


to get-route

  file-close-all

  set file-name(word stucurbldg "_Routes.csv")  ; set data-source to the Routes file


  file-open file-name
  set route-record csv:from-row file-read-line ; read to skip the heading line
  set route-wayptremain  9

  while [route-wayptremain != 0]
    [
       set route-record csv:from-row file-read-line

          if stucurbldg = route-currbldg
              and  stucurroom = route-currclrm
              [walk-to-waypoint]

    ]

  file-close-all

end

 ;         route-record
 ;         route-currbldg                               ;; itme 0
;          route-currclrm                               ;; item 1
;          route-destbldg                               ;; item 2
;          route-destclrm                               ;; item 3
;          route-wayptxcor                              ;; item 4
;          route-wayptycor                              ;; item 5
;          route-waypthead                              ;; item 6
;          route-wayptremain                            ;; item 7
;          route-wayptbel                               ;; itme 8



to walk-to-waypoint


  set studestlat route-wayptxcor
  set studestlon route-wayptycor
  set studesthead route-waypthead

  checkxy
  setup-move

       if item 7 data = 0
         [
           set last-waypoint 1
           set stucurroom item 3 data
           set stucurbldg item 2 data
         ]

end

to checkxy
    ;;  print "checkxy"
        if stucurlat > max-pxcor
          [
           output-print sentence "stucurlat greater than max-pxcor : " stucurlat
           output-print sentence "max-pxcor : " max-pxcor
           set outofworld 1

          ]
        if stucurlat  < min-pxcor
           [
            output-print sentence " stucurlat less than min-pxcor : " stucurlat
            set outofworld 1
           ]

        if stucurlon > max-pycor
          [
            output-print sentence "stucurlon greater than max-pycor : " stucurlon
            set outofworld 1
          ]

        if stucurlon < min-pycor
           [
            output-print sentence "stucurlon less than min-pycor : " stucurlon
            set outofworld 1
          ]

          if stucurlat > max-pxcor
          [
            output-print sentence "stucurlat greater than max-pxcor : " stucurlat
            output-print sentence "max-pxcor : " max-pxcor
           set outofworld 1

          ]
        if studestlat  < min-pxcor
           [
            output-print sentence " studestlat less than min-pxcor : " studestlat
            set outofworld 1
           ]

        if studestlon > max-pycor
          [
            output-print sentence "studestlon greater than max-pycor : " studestlon
            set outofworld 1
          ]

        if studestlon < min-pycor
           [
            output-print sentence "studestlon less than min-pycor : " studestlon
            set outofworld 1
           ]
end

to setup-move
  ;;  print "setup-move"
  if stucurlon < studestlon and studesthead = 0
    [
      set repeatval studestlon - stucurlon
      do-move-0
    ]
  if stucurlat < studestlat and studesthead = 90
    [
      set repeatval studestlat - stucurlat
      do-move-90
    ]
    if stucurlon > studestlon and studesthead = 180
    [
      set repeatval stucurlon - studestlon
      do-move-180
    ]
    if stucurlat > studestlat and studesthead = 270
    [
      set repeatval stucurlat - studestlat
      do-move-270
    ]

end

to do-move-0
  ;; print  "do-move-0"
        while [stucurlon < studestlon]
         [
          ask students
           [
            setxy stucurlat stucurlon
            set heading studesthead
            repeat repeatval [ fd 1] ;; set pcolor green]]
           ]

      set stucurlon stucurlon + repeatval
    ]

end

to do-move-90
  ;; print  "do-move-90"
      while [stucurlat < studestlat]
       [
          ask students
           [
            setxy stucurlat stucurlon
            set heading studesthead
          repeat repeatval [ fd 1] ;; set pcolor green]]
          ]

      set stucurlat stucurlat + repeatval
    ]
end

to do-move-180
  ;; print  "do-move-180"
        while [stucurlon > studestlon]
         [
          ask students
           [
            setxy stucurlat stucurlon
            set heading studesthead
           repeat repeatval [ fd 1] ;; set pcolor green]]
          ]
      set stucurlon stucurlon - repeatval
    ]
end

to do-move-270
  ;; print  "do-move-270"
        while [stucurlat > studestlat]
         [
          ask students
           [
            setxy stucurlat stucurlon
            set heading studesthead
            repeat repeatval [ fd 1]

          ]
      set stucurlat stucurlat - repeatval
    ]
end
@#$#@#$#@
GRAPHICS-WINDOW
235
-72
1502
693
-1
-1
3.14
1
8
1
1
1
0
0
0
1
-200
200
-120
120
0
0
1
ticks
0.25

BUTTON
3
10
66
43
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
-5
51
85
84
Next Class
next-class
NIL
1
T
TURTLE
NIL
NIL
NIL
NIL
1

BUTTON
95
12
214
45
Arrive at School
set stucurlat 195\nset stucurlon -19\nset stucurbell 0\nset stucurbldg \"High School\"\nset stucurroom 0\nset stucurhead 180\n\ncreate_student
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
1
425
106
470
File Curr Bldg
item 0 data
17
1
11

MONITOR
115
427
221
472
File Curr Class room
item 1 data
17
1
11

MONITOR
3
473
107
518
File Dest Bldg
item 2 data
17
1
11

MONITOR
115
475
223
520
Dest classroom
item 3 data
17
1
11

MONITOR
1
520
107
565
Next WP Lat
item 4 data
17
1
11

MONITOR
111
525
218
570
Next WP Lon
item 5 data
17
1
11

MONITOR
-5
569
105
614
Next WP Heading
item 6 data
17
1
11

MONITOR
112
572
223
617
Remaining Waypoints
item 7 data
17
1
11

MONITOR
3
88
87
133
Stu Curr Bldg
stucurbldg
17
1
11

MONITOR
2
133
67
178
NIL
stucurroom
17
1
11

MONITOR
-2
227
65
272
NIL
stucurlat
17
1
11

MONITOR
1
273
65
318
NIL
stucurlon
17
1
11

MONITOR
3
322
68
367
NIL
stucurhead
17
1
11

MONITOR
4
680
321
725
NIL
data
17
1
11

MONITOR
4
618
92
663
NIL
last-waypoint
17
1
11

MONITOR
127
616
184
661
NIL
steps
17
1
11

MONITOR
3
180
64
225
NIL
stucurbell
17
1
11

MONITOR
146
87
210
132
dest bldg
studestbldg
17
1
11

MONITOR
82
134
152
179
Dest room
studestroom
17
1
11

MONITOR
67
227
136
272
NIL
studestlat
17
1
11

MONITOR
65
273
136
318
NIL
studestlon
17
1
11

MONITOR
69
321
140
366
NIL
studesthead
17
1
11

MONITOR
147
322
213
367
NIL
repeatval
17
1
11

OUTPUT
-2
368
228
422
11

MONITOR
29
748
302
793
NIL
layout-record
17
1
11

MONITOR
325
680
1172
725
route-record
route-record
17
1
11

MONITOR
429
743
548
788
NIL
route-wayptremain
17
1
11

MONITOR
612
743
773
788
NIL
file-name
17
1
11

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
