globals [
          curr-xcor                                     ;; Student current x coordinate
          curr-ycor                                     ;; Student current y coordinate
          student-dest-xcor                             ;; Student destination x coordinate
          student-dest-ycor                             ;; Student destination y coordinate
  ;;      Waypoints
       datetime
          date
          time
         mouse-clicked
         file-name
         check-type
         repeatval
         location

  ;; Wall Layout Record Format
          layout-record
          layout-building                               ;; item 0
          layout-orientation                            ;; item 1
          layout-type                                   ;; item 2
          layout-color                                  ;; item 3
          layout-ns-start-xcor                          ;; item 4
          layout-ns-start-ycor                          ;; item 5
          layout-ns-end-xcor                            ;; item 6
          layout-ns-end-ycor                            ;; item 7
          layout-ew-start-xcor                          ;; item 8
          layout-ew-start-ycor                          ;; item 9
          layout-ew-end-xcor                            ;; item 10
          layout-ew-end-ycor                            ;; item 11
          layout-heading                                ;; item 12
          layout-line-type

   ;; Classroom Label Format
          label-record
          label-building                                ;; item 0
          label-classroom-label                         ;; item 1
          label-xcor                                    ;; item 2
          label-ycor                                    ;; item 3

   ;; Waypoint record
         waypoint-record
          waypoint-building
          waypoint-location
          waypoint-id
      ;;    waypoint-type   Global Defined on interface
          waypoint-xcor
          waypoint-ycor
          waypoint-color


]
breed[wall-makers wall-maker]  ;; Breed and turtle for building layout

breed [wpmakers wpmaker]
extensions [csv bitmap]


to setup
  ca
  ask patches [ set pcolor white ]
  set waypoint-id 0
  set mouse-clicked "False"

  reset-ticks
  make-turtle


end

to load-image

  set file-name (word building "_layout.csv")


   file-open file-name
        set layout-record csv:from-row file-read-line ; skip header record

   while [not file-at-end?]
    [
      set layout-record csv:from-row file-read-line ; read building layout paramenters
      set layout-building item 0 layout-record
      set layout-orientation item 1 layout-record
      set layout-type item 2 layout-record
      set layout-color item 3 layout-record
      set layout-ns-start-xcor item 4 layout-record
      set layout-ns-start-ycor item 5 layout-record
      set layout-ns-end-xcor item 6 layout-record
      set layout-ns-end-ycor item 7 layout-record
      set layout-ew-start-xcor item 8 layout-record
      set layout-ew-start-ycor item 9 layout-record
      set layout-ew-end-xcor item 10 layout-record
      set layout-ew-end-ycor item 11 layout-record
      set layout-heading item 12 layout-record
      set layout-building building

     if layout-orientation = "NS"
        [
           set   xcor layout-ns-start-xcor
           set   ycor layout-ns-start-ycor
           set repeatval abs layout-ns-start-ycor - abs layout-ns-end-ycor
           setxy xcor ycor
           set heading 180
           while [ycor > layout-ns-end-ycor]
             [
               ask wpmaker 0 [set pcolor layout-color]  ;; set the patch color
                ask wpmaker 0 [set plabel-color layout-color]
;                set check-type substring layout-line-type  0 2
                ask wpmaker 0 [set pcolor layout-color]
                ask wpmaker 0 [ fd 1 ]
            ]
        ]


     if layout-orientation = "EW"
        [
           set   xcor layout-ew-start-xcor
           set   ycor layout-ew-start-ycor
           setxy xcor ycor
           set heading 90
           while [xcor < layout-ew-end-xcor]
             [
                ask wpmaker 0 [set pcolor layout-color]  ;; set the patch color
                ask wpmaker 0 [set plabel-color layout-color]
;                set check-type substring layout-line-type  0 2
                ask wpmaker 0 [set pcolor layout-color]
                ask wpmaker 0 [ fd 1 ]
            ]
        ]
     ]


  set file-name (word building "_layout.csv")

  file-close


       set file-name (word building "_Classrooms.csv")

     file-open file-name

     set label-record csv:from-row file-read-line ; skip header record

     while [not file-at-end?]
    [
          set label-record csv:from-row file-read-line ; read classroom label paramenters



       set label-classroom-label item 1 label-record
        set label-xcor item 2 label-record
        set label-ycor item 3 label-record
         set xcor label-xcor
         set ycor label-ycor         ;; get the y coordinate of the click as an integer
         setxy xcor ycor
         ask wpmaker 0 [set plabel-color black]
    ask wpmaker 0 [set pcolor white]
         ask wpmaker 0 [set plabel label-classroom-label]

   ;;     ask wpmaker 0 [fd 1]
  ]

  set file-name (word building "_Classrooms.csv")

  file-close



end

to make-turtle
    create-turtles 1 [
                    set breed wpmakers set color red


                    set curr-xcor 195
                    set curr-ycor -32
                    set size 4 setxy curr-xcor curr-ycor
                   ]
  reset-ticks
end





to setup-waypoint                   ; Setup to mark a waypoint when mouse is clicked and setup to capture the location
                                    ; of the mouse click

  if mouse-down?                    ; Detect a mouse click by the user
  [
    set mouse-clicked "True"        ; Say the mouse has been clicked this will insure that the mouse click only presents
                                    ; one set of data to the procedure to capture the location
    get-mouse-click                 ; Go process the mouse click
    set mouse-clicked "False"       ; Reset the mouse click tracker
    stop                            ; Stop the waypoint processing unitl the next request to mark a waypoint
  ]

end

to get-mouse-click                 ; Process the data from the mouse clidk

  ifelse mouse-clicked = "True"
  ;;        TRUE
        [
           ask patch round mouse-xcor  round mouse-ycor [ set pcolor 0 ]
           set waypoint-id waypoint-id + 1            ;; Increment the waypoint id
           set xcor round mouse-xcor                  ;; Get the x coordinate of the click as an integer
           set ycor round mouse-ycor                  ;; get the y coordinate of the click as an integer
           setxy xcor ycor                            ;; set the location of the turtle
           set waypoint-xcor xcor                     ;; get the location to be recorded in the file
           set waypoint-ycor ycor
           set check-type substring waypoint-type 0 1
           if check-type = "E" [set waypoint-color orange]
           if check-type = "I" [set waypoint-color violet]
           if check-type = "O" [set waypoint-color white]
           set waypoint-color black
           ask wpmaker 0 [set pcolor white]  ;; set the patch color
           ask wpmaker 0 [set plabel-color waypoint-color]  ;; Set the color of the label for the waypoint
           ask wpmaker 0 [set plabel waypoint-id]           ;; Mark the patch with the waypoint id

       ]
;;           FALSE
       [
          set mouse-clicked "False"
 ]


end



to capture-waypoint
  if building = "High School" [set waypoint-location hs-waypoint-location]
  if building = "Ag Building" [set waypoint-location ag-waypoint-location]
  if building = "Cafeteria"   [set waypoint-location ca-waypoint-location]
  if building = "New Gym"     [set waypoint-location ng-waypoint-location]
  if building = "High School to New Gym" [set waypoint-location hsng-waypoint-location]

  set waypoint-record (list building waypoint-location waypoint-id waypoint-type waypoint-xcor waypoint-ycor waypoint-color)
  file-print csv:to-row waypoint-record

end

to save-waypoint-file
  ask turtles [die]
  file-close-all

end

to append-wayfile
   set file-name (word building "_waypoints.csv")

   file-open file-name
        set waypoint-record csv:from-row file-read-line ; skip header record

   while [not file-at-end?]
    [
      set waypoint-record csv:from-row file-read-line ; read building layout paramenters
;;      set building item 0 waypoint-record
;;      set waypoint-location item 1 waypoint-record
      set waypoint-id  item 2 waypoint-record
;;      set waypoint-type item 3 waypoint-record
      set waypoint-xcor item 4 waypoint-record
      set waypoint-ycor item 5 waypoint-record
      set waypoint-color item 6 waypoint-record
      map-existing
   ]
file-close-all
   set file-name (word building "_waypoints.csv")
  file-open file-name


end

to map-existing
;; pen-down

set xcor waypoint-xcor
set ycor waypoint-ycor
set pcolor white
set plabel-color waypoint-color
  set plabel waypoint-id
;; pen-up

end
@#$#@#$#@
GRAPHICS-WINDOW
486
17
1753
782
-1
-1
3.14
1
8
1
1
1
0
0
0
1
-200
200
-120
120
0
0
1
ticks
0.25

BUTTON
0
10
64
43
Setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
55
10
157
43
Draw Building
load-image
NIL
1
T
TURTLE
NIL
NIL
NIL
NIL
1

MONITOR
5
475
85
520
Current Xcor
curr-xcor
17
1
11

MONITOR
105
475
212
520
Curr-Ycor
curr-ycor
17
1
11

CHOOSER
280
10
462
55
Building
Building
"High School" "Ag Building" "Cafeteria" "New Gym" "High School to New Gym"
0

CHOOSER
5
60
195
105
hs-waypoint-Location
hs-waypoint-Location
"High School East Entrance" "High School East/West Hallway" "High School Office" "Mrs Watson" "Mr Roybal" "Ladies Restroom" "Mens Restroom" "Mr. Jackson" "Mrs. Clemmons" "Mrs. Montague" "Mrs. Cooper" "High School North Hallway" "Library" "Lounge" "Computer Lab" "Science Workroom" "Mr Daugherty" "Science Lab" "High School North Entrance" "High School South Entrance" "High School North Parking"
6

BUTTON
125
275
225
308
Capture Waypoint
capture-waypoint
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
235
275
340
308
Save Waypoint  File
save-waypoint-file
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
170
225
317
270
waypoint-type
waypoint-type
"External Doorway" "Internal Doorway" "Turnpoint" "Outside Turnpoint"
0

BUTTON
20
275
120
308
Setup Waypoint
setup-waypoint
T
1
T
TURTLE
NIL
NIL
NIL
NIL
1

MONITOR
15
320
285
365
Waypoint File Name
file-name
17
1
11

MONITOR
10
375
395
420
Waypoint Record
waypoint-record
17
1
11

MONITOR
230
475
322
520
NIL
waypoint-color
17
1
11

BUTTON
160
10
270
43
Append Waypoint File
Append-wayfile
NIL
1
T
TURTLE
NIL
NIL
NIL
NIL
1

MONITOR
5
425
142
470
NIL
item 0 waypoint-record
17
1
11

MONITOR
150
425
287
470
NIL
item 1 waypoint-record
17
1
11

MONITOR
295
425
372
470
NIL
waypoint-id
17
1
11

TEXTBOX
70
45
220
63
High School
11
0.0
1

CHOOSER
285
75
437
120
ag-waypoint-location
ag-waypoint-location
"West Outside Door"
0

TEXTBOX
330
55
480
73
Ag Building
11
0.0
1

CHOOSER
275
140
462
185
ca-waypoint-location
ca-waypoint-location
"North Doorway"
0

TEXTBOX
300
120
450
138
Cafeteria Building
11
0.0
1

CHOOSER
0
120
187
165
hsng-waypoint-location
hsng-waypoint-location
"High School North Door" "Turnpoint for Sidewalk" "North/South Sidewalk" "Curry Rd 12" "Gym Parking Lot Entrance" "New Gym Entrance"
5

TEXTBOX
30
105
180
123
High School to New Gym
11
0.0
1

CHOOSER
5
180
157
225
ng-waypoint-location
ng-waypoint-location
"New Gym Entrance"
0

TEXTBOX
50
165
200
183
New Gym
11
0.0
1

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
1
@#$#@#$#@
